function eco_graph = jgraph_threshold_max_eco(W,directed)
% A is distence matrix
%Reference "A topological criterion to filter information in complex brain
%networks, De Vico Fallani et al, Plos Comp Biol, 2017

%%%

N=size(W,1);

if directed
    numcon=3*N;
    ind=find(W);
else
    W=triu(W);
    numcon=1.5*N;
    ind=find(triu(W));
end

if numcon>length(ind)
    error('Input matrix is too sparse')
end

sorind=sortrows([ind W(ind)],-2);

W(sorind(numcon+1:end,1))=0;

if directed
    A=double(logical(W));
else
    A=double(logical(W+W'));
end
eco_graph = A.*W;
eco_graph = eco_graph + eco_graph';